<?
//force the content type so it opens in google earth
header("Content-type: application/vnd.google-earth.kml+xml");

//Constants
//You can change these values
define("MYSQLUSER", "");
define("MYSQLPASSWORD", "");
define("DEFAULTRANGE", "365");
define("DEFAULTHEADING", "0");
define("DEFAULTTILT", "20");
define("MAXCALL", 20);	//defines the maximum number of callsigns that can be included in the url

//breaks down calls in url to an array
$call_arr = explode(",", $_GET['call'],20);

//steps through the call array, validating each call, then adding it to the query string used to poll the database
foreach ($call_arr as $call) {
	if (ereg("^[a-zA-Z0-9]{1,6}(\-[0-9]{1,2})?$",$call)) {
		if (isset($where)) $where .= " OR";
		$where .= " source='$call'";
	}
	else die("Call not formatted properly.");
}

//connect to aprs world database
$db = mysql_connect ("db.aprsworld.net", MYSQLUSER, MYSQLPASSWORD) or die ('Cannot connect to the database because: ' . mysql_error());
mysql_select_db ("aprs");

//useful information about 'lastposition' table
/*//////////////////////////////////////////////////////////////////////////
mysql> DESCRIBE lastposition;
Field			Type				Null	Key		Default				Extra
packet_id 		bigint(20) unsigned	NULL 	NULL 	0				 	NULL
packet_date 	datetime 			NULL 	NULL 	0000-00-00 00:00:00 NULL
source 			varchar(9) 			NULL 	PRI 	NULL 				NULL
latitude 		double(8,6) 		NULL 	MUL 	0.000000 			NULL
longitude 		double(8,6) 		NULL 	MUL 	0.000000 			NULL
course 			smallint(5) unsignedYES 	NULL 	NULL 				NULL
speed 			smallint(5) unsignedYES 	NULL 	NULL 				NULL
altitude	 	mediumint(9)		YES 	NULL 	NULL 				NULL
status 			tinytext 			YES 	NULL 	NULL 				NULL
symbol_table 	char(1) 			YES 	NULL 	NULL 				NULL
symbol_code 	char(1) 			YES 	NULL 	NULL 				NULL
*//////////////////////////////////////////////////////////////////////////
//query aprs world database
$result = mysql_query("SELECT source,latitude,longitude,course,altitude,status FROM lastposition WHERE$where LIMIT 20;");

//set tilt: value in url has top priority, then default
$tilt = DEFAULTTILT;
if ($_GET['tilt'] != "") $tilt = $_GET['tilt'];

//set range: value in url has top priority, then default
$range = DEFAULTRANGE;
if ($_GET['range'] != "") $range = $_GET['range'];

//begin xml output. this is a little tricky because it starts with the same tag as php
echo('<?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://earth.google.com/kml/2.1">
<Document>
    <name>APRS World (kml by KD7LXL)</name>
    <open>1</open>
');

while ($station = mysql_fetch_assoc($result)) {
	//set altitude if mysql returned null
	if ($station['altitude'] == NULL) $station['altitude'] = "0";
	
	//set heading: value in url has top priority, then database value, then default
	$heading = DEFAULTHEADING;
	if ($station['heading'] != NULL) $heading = $station['heading'];
	if ($_GET['az'] != "") $heading = $_GET['az'];
	
	//make status kml friendly by converting < to &lt; and > to &gt;
	$station['status'] = str_replace("<", "&lt;", $station['status']);
	$station['status'] = str_replace(">", "&gt;", $station['status']);
?>
	<Placemark>
		<name><?=$station['source']?></name>
		<description><?=$station['status']?></description>
		<LookAt>
			<longitude><?=$station['longitude']?></longitude>
			<latitude><?=$station['latitude']?></latitude>
			<range><?=$range?></range>
			<heading><?=$heading?></heading>
			<tilt><?=$tilt?></tilt>
		</LookAt>
		<styleUrl>#khStyle615</styleUrl>
		<Style>
			<IconStyle>
			<scale>1</scale>
			<Icon>
			<href>root://icons/palette-4.png</href>
			<x>128</x>
			<w>32</w>
			<h>32</h>
			</Icon>
			</IconStyle>
			<LineStyle>
			<width>5</width>
			</LineStyle>
		</Style>
		<Point>
			<extrude>1</extrude>
			<altitudeMode>relativeToGround</altitudeMode>
			<coordinates><?=$station['longitude']?>,<?=$station['latitude']?>,<?=$station['altitude']?></coordinates>
		</Point>
	</Placemark>
<? } ?></Document>
</kml>
